// Generyczna klasa kolejki o staym rozmiarze.
class GenQueue<T> implements IGenQ<T> {      
  private T q[]; // tablica przechowujca elementy kolejki     
  private int putloc, getloc; // indeksy operacji put i get
      
  // Tworzy kolejk wykorzystujc tablic aRef.     
  public GenQueue(T[] aRef) {   
    q = aRef;  
    putloc = getloc = 0;      
  }      
     
  // Umieszcza element w kolejce.      
  public void put(T obj)  
    throws QueueFullException {      
  
    if(putloc==q.length-1)   
      throw new QueueFullException(q.length-1);  
          
    putloc++;      
    q[putloc] = obj;      
  }      
      
  // Pobiera element z kolejki.     
  public T get()  
    throws QueueEmptyException {      
  
    if(getloc == putloc)   
      throw new QueueEmptyException();  
        
    getloc++;      
    return q[getloc];      
  }      
}
